# -*- coding: utf-8 -*-
from setuphelpers import *
import json
import base64
from waptcrypto import SSLCertificate
import waptguihelper
from common import WaptServer
from common import get_requests_client_cert_session
import waptlicences


encrypted_txt_file = "encrypted_txt.json"


def update_package():
    srvwapt_url = inifile_readstring(makepath(install_location("WAPT_is1"), "wapt-get.ini"), "global", "wapt_server")
    credentials_url = waptguihelper.login_password_dialog("Credentials for WAPT Server", srvwapt_url, "admin", "")

    encrypt_txt = waptguihelper.input_dialog("Encrypting with WAPT", "Enter the text to be encrypted: ", "")
    if not encrypt_txt:
        error("Please provide text to be encrypted")

    t = waptlicences.waptserver_login(WAPT.config_filename,credentials_url["user"],credentials_url["password"])
    s = get_requests_client_cert_session(srvwapt_url,  
    cert=(t['client_certificate'],t['client_private_key'],t['client_private_key_password']),
    verify=False
    )
    s.cookies.set(t['session_cookies'][0]['Name'], t['session_cookies'][0]['Value'], domain=t['session_cookies'][0]['Domain'])
    
    host_crt = s.get(f"{srvwapt_url}/api/v3/hosts?columns=host_certificate&limit=1000000")
    data = json.loads(host_crt.content)['result']

    encrypt_dict={}
    for value in data:
        if value["host_certificate"]:
            host_cert = SSLCertificate(crt_string=value["host_certificate"])
            encrypt_dict[value["uuid"]] = base64.b64encode(host_cert.encrypt(encrypt_txt.encode("utf-8"))).decode("utf-8")
            print(value["computer_fqdn"] + ":" + value["uuid"] + ":" + encrypt_dict[value["uuid"]])

    json_write_file(encrypted_txt_file, encrypt_dict)
